VERSION 5.00
Begin VB.Form SocketDemoForm 
   Caption         =   "Collabrary.Socket Demo"
   ClientHeight    =   1755
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   14.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   1755
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton SendTimeButton 
      Caption         =   "Send time"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   1800
      TabIndex        =   0
      Top             =   1080
      Width           =   1095
   End
   Begin VB.Label TimeLabel 
      Caption         =   "<<Not yet sent>>"
      Height          =   735
      Left            =   1560
      TabIndex        =   2
      Top             =   120
      Width           =   3015
   End
   Begin VB.Label Label1 
      Caption         =   "Received time:"
      Height          =   855
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "SocketDemoForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' SocketDemo
'
' Demonstrates how to use the low-level TCP socket support provided by
' the Collabrary without the overhead of the shared dictionary.
'
' This example program starts a server to listen for incoming connections,
' then starts a client to connect to the server.  The server then accepts the
' incoming connection and the two can communicate.
'
' The obvious limitation of this program is that this program can only maintain
' one connection to a client at a time, even though the listening socket
' is available for further connections.  That is, if a second client connects
' the first will be booted out.
'
Option Explicit

Dim WithEvents ServerListeningSocket As Collabrary.Socket
Attribute ServerListeningSocket.VB_VarHelpID = -1
Dim WithEvents ClientConnectingSocket As Collabrary.Socket
Attribute ClientConnectingSocket.VB_VarHelpID = -1
Dim WithEvents ServerAcceptedSocket As Collabrary.Socket
Attribute ServerAcceptedSocket.VB_VarHelpID = -1

Private Sub SendTimeButton_Click()
    Dim Buf As New Collabrary.Buffer
    Buf.Paste Now, Value
    ServerAcceptedSocket.Frame Buf
End Sub

Private Sub Form_Load()
    Set ServerListeningSocket = New Collabrary.Socket
    Set ClientConnectingSocket = New Collabrary.Socket
    ServerListeningSocket.AutoUnframe = Binary
    ClientConnectingSocket.AutoUnframe = Binary
    ServerListeningSocket.Open "tcp://*:test"
End Sub

Private Sub ServerListeningSocket_Opened(ByVal Url As String, ByVal isServer As Boolean)
    ClientConnectingSocket.Open "tcp://localhost:test"
End Sub

Private Sub ServerListeningSocket_Accepting()
    Set ServerAcceptedSocket = ServerListeningSocket.Accept()
End Sub

Private Sub ClientConnectingSocket_Opened(ByVal Url As String, ByVal isServer As Boolean)
    SendTimeButton.Enabled = True
End Sub

Private Sub ClientConnectingSocket_Unframed(ByVal data As Collabrary.IBuffer)
    TimeLabel.Caption = CStr(data.Copy(Value))
End Sub
